package com.base.api.client;

import com.base.api.model.SatelliteStationMatchRpcDTO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(name = "orbit-base-biz", contextId = "stationmatch")
public interface SatelliteStationMatchRpcService {

    @RequestMapping(value = "/rpc/stationmatch/list", method = RequestMethod.GET)
    public List<SatelliteStationMatchRpcDTO> getBySatelliteCodeAndStationCode(@RequestParam("satelliteCodeList") List<String> satelliteCodeList, @RequestParam("stationCodeList")List<String> stationCodeList);
}