package com.base.biz.model.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


@Data
public class InstanceInfoDTO {

    private String id;
    @ApiModelProperty("卫星代号")
    private String satelliteCode;
    @ApiModelProperty("圈号")
    private String orbitNum;
    @ApiModelProperty("历元时刻(北京时间)")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date epochTime;
    @ApiModelProperty("轨道半径长 米")
    private String semiMajorAxis;
    @ApiModelProperty("偏心率")
    private String eccentricity;
    @ApiModelProperty("轨道倾角")
    private String inclination;
    @ApiModelProperty("近地点俯角")
    private String argumentOfPerigee;
    @ApiModelProperty("平近点角")
    private String meanAnoMaly;
    @ApiModelProperty("升交点赤经")
    private String raan;
}

