package com.base.biz.model.dto.request;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
public class QueryStationAddDTO {

    @ApiModelProperty("地面站id，只有修改的时候才会用到，新增不传值")
    private String id;

    @ApiModelProperty("地面站代号")
    private String stationCode;
    @ApiModelProperty("名称")
    private String stationName;
    @ApiModelProperty("资源类型 0地面站 1中继星")
    private String resourceType;
    @ApiModelProperty("任务类型")
    private String missionType;
    @ApiModelProperty("经度")
    private String longitude;
    @ApiModelProperty("纬度")
    private String latitude;
    @ApiModelProperty("高度")
    private String altitude;
    @ApiModelProperty("最小跟踪仰角，默认3度")
    private String minTraceElevation;
    @ApiModelProperty("最小接收仰角，默认5度")
    private String minWorkElevation;
    @ApiModelProperty("基带类型")
    private String basebandType;
    @ApiModelProperty("数传速率")
    private String receivedRate;
    @ApiModelProperty("日凌角")
    private String sundialCorer;
    @ApiModelProperty("创建时间")
    private Date createTime;
    @ApiModelProperty("修改时间")
    private Date updateTime;

    private Integer antMinRecvElevation;

    private Integer sundialCorner;
    @ApiModelProperty("中继星能里，0无，1一代，2二代")
    private Integer relayType;
}