package com.base.biz.model.dto.request;

import com.base.biz.model.PointDTO;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

@Data
public class QueryTargetRelationPointAddDTO {

    @ApiModelProperty("目标名称")
    private String targetName;
    @ApiModelProperty("点集合")
    private List<PointDTO> pointDTOList;
    @ApiModelProperty("目标类型")
    private Integer type;
    @ApiModelProperty("级别")
    private Integer targetLevel;
    @ApiModelProperty("国别")
    private String countryName;
    @ApiModelProperty("区域点顺序走向，0顺时针，1逆时针")
    private Integer pointDirection;
    @ApiModelProperty("优先级")
    private Integer priority;
    @ApiModelProperty("频次")
    private Integer rate;
    @ApiModelProperty("开始时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date startTime;
    @ApiModelProperty("结束时间")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date endTime;
    @ApiModelProperty("父ID")
    private String parentId;

}