package com.base.core;

import com.base.core.model.enity.Eph;
import com.base.core.config.ImageLimitation;
import com.base.core.model.enity.SubPoint;
import java.util.Date;
import java.util.List;

public interface BizService {

    /**
     * 获取业务星历，带经纬度
     * @param code 卫星唯一编号
     * @param startTime 请求开始时间
     * @param endTime 请求结束时间
     * @return 星历数据
     */
    List<Eph> getBizEphList(String code, Date startTime, Date endTime);

    /**
     * 获取业务星下点
     * @param code 卫星唯一编号
     * @param startTime 请求开始时间
     * @param endTime 请求结束时间
     * @return 星下点数据
     */
    List<SubPoint> getBizSubPointList(String code, Date startTime, Date endTime,String updown);

    /**
     * 根据卫星和载荷查询
     * @param satelliteCode 业务卫星code
     * @param payloadId 业务载荷数据库id
     * @return 访问计算限制条件
     */
    void getImageLimitation(String satelliteCode, ImageLimitation imageLimitation);

    /**
     * 获取业务星下点
     * @param code 卫星唯一编号
     * @param startTime 请求开始时间
     * @param endTime 请求结束时间
     * @return 星下点数据
     */
    List<SubPoint> getBizSubPointList(String code, Date startTime, Date endTime);

}