package com.base.plan.mapper;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.base.plan.model.dto.QuerySelectedStripUpdateDTO;
import com.base.plan.model.dto.request.StripDTOListReqDTO;
import com.base.plan.model.entity.AlgSchemeStepWindow;
import com.base.plan.model.entity.StripInfo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.Collection;
import java.util.List;
import java.util.Set;

@Mapper
@Repository
public interface StripMapper extends BaseMapper<StripInfo> {

    List<StripInfo> getStripInfoList(@Param("req") StripDTOListReqDTO req);


    void delStripByReqId(@Param("req") List<String> req);

    void updateSelectedStatus(@Param("list") List<QuerySelectedStripUpdateDTO> list);


    void initSelected(@Param("parentId") String parentIdSubstring);

    void initSelectedByList(@Param("parentIds") List<String> parentIds);

    void batchUpdateSelectedStatus(@Param("windowIds") List<String> windowIds);
}
