package com.base.plan.model.dto;

import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @类名: ReportPoint
 * @描述: 记录观测区域最西、最东顶点的经度和最北、最南顶点的纬度
 * @版本:
 * @创建日期: 2022年3月15日15点15分
 * @作者: cxl
 * @JDK: 1.8
 */
@Data
@NoArgsConstructor
public class ReportPointDTO {


    /**
     * 最西顶点的经度
     */
    private double w_node_lon;
    /**
     * 最东顶点的经度
     */
    private double e_node_lon;
    /**
     * 最北顶点的纬度
     */
    private double n_node_lat;
    /**
     * 最南顶点的纬度
     */
    private double s_node_lat;

    public ReportPointDTO(double w_node_lon, double e_node_lon, double n_node_lat, double s_node_lat) {
        super();
        this.w_node_lon = w_node_lon;
        this.e_node_lon = e_node_lon;
        this.n_node_lat = n_node_lat;
        this.s_node_lat = s_node_lat;
    }
}
