package com.base.plan.model.entity;

import com.base.api.model.SubPointDataRpcDTO;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;



/**
 * @类名: 轨迹实体类
 * @描述: 轨迹点数组的轨迹类
 * @版本:
 * @创建日期: 2015-04-13下午04:23:37
 * @作者: liuchl
 * @JDK: 1.7
 */
@Data
public class EphTrack {


    /**
     * 轨道节点
     */
    private List<SubPointDataRpcDTO> subPointlist = new ArrayList<SubPointDataRpcDTO>();
    /**
     * 卫星标识
     */
    private String satalliteid = "";
    /**
     * 卫星编码
     */
    private String satallitCode = "";
    /**
     * 载荷约束限制
     */
    private PayloadLMT payloadLMT = new PayloadLMT();

    /**
     * 升降轨标识，1为降轨，0为升轨
     */
    private String updown = "";

    /**
     * 轨迹完成状态
     */
    private boolean flag = false;


    public void addSubPoint(SubPointDataRpcDTO subpoint){
        this.subPointlist.add(subpoint);
    }

}
