package com.base.plan.model.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

@Data
@TableName("strip_info")
public class StripInfo {

    @TableId
    private String id;
    private String reqId;
    private String targetId;
    private String targetName;
    private String windowId;
    private String priority;
    private String satelliteId;
    private String satelliteCode;
    private String payloadId;
    private Date observationStartTime;
    private Date observationEndTime;
    private String rollAngle;
    private String trbutId;
    private String createTime;
    private String updateTime;
    @ApiModelProperty("覆盖率")
    @TableField(value = "coverage_rate")
    private String coverageRate;
    @ApiModelProperty("圈号")
    @TableField(value = "cir_cle")
    private String circle;
    @ApiModelProperty("网格编码")
    @TableField(exist = false)
    private List<String> girdCodeList;

    private String workMode;

    @TableField(value = "grid_ids")
    private String gridIds;

    @ApiModelProperty("区域目标点的parentID")
    private String parentId;

    @ApiModelProperty("分辨率 单位米")
    private Double groundResolution;
    @ApiModelProperty("俯仰角")
    private Double pitchAngle;

    @ApiModelProperty("是否被选中，1：不是；2：是")
    private Integer isSelected;
}
