package com.base.plan.mq.model;

import com.baomidou.mybatisplus.annotation.TableField;
import com.base.plan.model.entity.StripInfo;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

@Data
public class AreaOptimizationMqResultInfo {
    @ApiModelProperty("需求id")
    private String reqId;
    @ApiModelProperty("条带id")
    private String stripId;
    @ApiModelProperty("载荷id")
    private String payloadId;
    @ApiModelProperty("创建时间")
    private Date createDate;
    @ApiModelProperty("观测目标id")
    private String parentId;
    @ApiModelProperty("观测目标名称")
    private String parentName;
    @ApiModelProperty("覆盖率")
    private double coverage;
    @ApiModelProperty("任务开始时间")
    private Date startTime;
    @ApiModelProperty("任务结束时间")
    private Date endTime;

    @ApiModelProperty("条带id")
    @TableField(exist = false)
    private List<String> stripIds;

    @ApiModelProperty("条带集合")
    List<StripInfoMqDTO> stripInfos;

    @ApiModelProperty("条带中心点经度")
    private Double striplon;

    @ApiModelProperty("条带中心点纬度")
    private Double striplat;

    @ApiModelProperty("目标中心点经度")
    private Double lon;

    @ApiModelProperty("目标中心点纬度")
    private Double lat;
}
