package com.base.api.client;

import com.base.api.model.CalEphRpcDTO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.Date;
import java.util.List;


@FeignClient(name = "orbit-base-track",contextId = "eph")
public interface EphRpcService {

    /**
     * 读取txt文件解析eph数据
     * @param code 卫星id列表
     * @param startTime   开始时间
     * @param endTime  结束时间
     * @return
     */
    @GetMapping("/rpc/eph/list")
    public List<CalEphRpcDTO> selEphDataByFile(@RequestParam("code") String code, @RequestParam("startTime") String startTime, @RequestParam("endTime") String endTime);
}
